package com.mdd.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Assert;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.mdd.admin.service.IChannelOaReplyDefaultService;
import com.mdd.admin.validate.channel.ChannelRpDefaultValidate;
import com.mdd.admin.validate.commons.PageValidate;
import com.mdd.admin.vo.channel.ChannelRpDefaultVo;
import com.mdd.common.core.PageResult;
import com.mdd.common.entity.OfficialReply;
import com.mdd.common.mapper.OfficialReplyMapper;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.annotation.Resource;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class ChannelOaReplyDefaultServiceImpl implements IChannelOaReplyDefaultService {
   @Resource
   OfficialReplyMapper officialReplyMapper;

   public PageResult<ChannelRpDefaultVo> list(PageValidate pageValidate) {
      Integer pageNo = pageValidate.getPageNo();
      Integer pageSize = pageValidate.getPageSize();
      IPage<OfficialReply> iPage = this.officialReplyMapper.selectPage(new Page((long)pageNo, (long)pageSize), (Wrapper)((QueryWrapper)((QueryWrapper)(new QueryWrapper()).eq("reply_type", 3)).eq("is_delete", 0)).orderByDesc(Arrays.asList("sort", "id")));
      List<ChannelRpDefaultVo> list = new LinkedList();
      Iterator var6 = iPage.getRecords().iterator();

      while(var6.hasNext()) {
         OfficialReply officialReply = (OfficialReply)var6.next();
         ChannelRpDefaultVo vo = new ChannelRpDefaultVo();
         BeanUtils.copyProperties(officialReply, vo);
         list.add(vo);
      }

      return PageResult.iPageHandle(iPage.getTotal(), iPage.getCurrent(), iPage.getSize(), list);
   }

   public ChannelRpDefaultVo detail(Integer id) {
      OfficialReply officialReply = (OfficialReply)this.officialReplyMapper.selectOne((Wrapper)((QueryWrapper)((QueryWrapper)(new QueryWrapper()).eq("id", id)).eq("is_delete", 0)).last("limit 1"));
      Assert.notNull(officialReply, "默认数据不存在!", new Object[0]);
      ChannelRpDefaultVo vo = new ChannelRpDefaultVo();
      BeanUtils.copyProperties(officialReply, vo);
      return vo;
   }

   public void add(ChannelRpDefaultValidate defaultValidate) {
      OfficialReply officialReply;
      if (defaultValidate.getStatus().equals(1)) {
         officialReply = new OfficialReply();
         officialReply.setStatus(0);
         this.officialReplyMapper.update(officialReply, (Wrapper)(new QueryWrapper()).eq("reply_type", 3));
      }

      officialReply = new OfficialReply();
      officialReply.setReplyType(3);
      officialReply.setContent(defaultValidate.getContent());
      officialReply.setName(defaultValidate.getName());
      officialReply.setContentType(defaultValidate.getContentType());
      officialReply.setStatus(defaultValidate.getStatus());
      officialReply.setSort(defaultValidate.getSort());
      officialReply.setUpdateTime(System.currentTimeMillis() / 1000L);
      officialReply.setCreateTime(System.currentTimeMillis() / 1000L);
      this.officialReplyMapper.insert(officialReply);
   }

   @Transactional
   public void edit(ChannelRpDefaultValidate defaultValidate) {
      OfficialReply officialReply = (OfficialReply)this.officialReplyMapper.selectOne((Wrapper)((QueryWrapper)((QueryWrapper)(new QueryWrapper()).eq("id", defaultValidate.getId())).eq("is_delete", 0)).last("limit 1"));
      Assert.notNull(officialReply, "默认回复数据不存在!", new Object[0]);
      if (defaultValidate.getStatus().equals(1)) {
         OfficialReply reply = new OfficialReply();
         reply.setStatus(0);
         this.officialReplyMapper.update(reply, (Wrapper)(new QueryWrapper()).eq("reply_type", officialReply.getReplyType()));
      }

      officialReply.setReplyType(3);
      officialReply.setId(defaultValidate.getId());
      officialReply.setName(defaultValidate.getName());
      officialReply.setContent(defaultValidate.getContent());
      officialReply.setContentType(defaultValidate.getContentType());
      officialReply.setStatus(defaultValidate.getStatus());
      officialReply.setSort(defaultValidate.getSort());
      officialReply.setCreateTime(System.currentTimeMillis() / 1000L);
      officialReply.setUpdateTime(System.currentTimeMillis() / 1000L);
      this.officialReplyMapper.updateById(officialReply);
   }

   public void del(Integer id) {
      OfficialReply officialReply = (OfficialReply)this.officialReplyMapper.selectOne((Wrapper)((QueryWrapper)((QueryWrapper)(new QueryWrapper()).eq("id", id)).eq("is_delete", 0)).last("limit 1"));
      Assert.notNull(officialReply, "默认回复数据不存在了!", new Object[0]);
      officialReply.setIsDelete(1);
      officialReply.setDeleteTime(System.currentTimeMillis() / 1000L);
      this.officialReplyMapper.updateById(officialReply);
   }

   public void status(Integer id) {
      OfficialReply officialReply = (OfficialReply)this.officialReplyMapper.selectOne((Wrapper)((QueryWrapper)((QueryWrapper)(new QueryWrapper()).eq("is_delete", 0)).eq("id", id)).last("limit 1"));
      Assert.notNull(officialReply, "默认回复数据不存在!", new Object[0]);
      int status = officialReply.getStatus() == 1 ? 0 : 1;
      if (status == 1) {
         OfficialReply reply = new OfficialReply();
         reply.setStatus(0);
         reply.setUpdateTime(System.currentTimeMillis() / 1000L);
         this.officialReplyMapper.update(reply, (Wrapper)(new QueryWrapper()).eq("reply_type", officialReply.getReplyType()));
      }

      officialReply.setId(id);
      officialReply.setStatus(status);
      officialReply.setUpdateTime(System.currentTimeMillis() / 1000L);
      this.officialReplyMapper.updateById(officialReply);
   }
}
